/*
⨫ DTECount v1.11
ᠭ   ஥ RUSSIAN ROMS.

4  2000 . (c) Alexey Rojnov (2:5020/689.50)
*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#include "types.h"


#define COMB 65536


void parse();
void sort();
void result();


struct twochar
{
 ushort num;	//  樨
 uint sym;	// -  権   num
} symnum[COMB];
FILE *f;
int comb_num=COMB;
int sort_count=0;
char *copyright="\nDTECount v1.11 (c) Alexey Rojnov (2:5020/689.50)\n\n";


int main(int argc,char *argv[])
{
 int i,fname_arg=0;

 printf(copyright);

 for (i=0;i<argc;i++)
 {
  if (!strnicmp(argv[i],"-s",2))
  {
   if (!(sort_count=atol(&argv[i][2])))
    sort_count=65536;
   continue;
  }
  fname_arg=i;
 }

 if (!fname_arg)
 {
  printf("\
Usage: DTEC  [<options>]  <filename> [<options>]\n\
\n\
Options:\n\
	-sxxxxx	sorting last xxxxx DTE in output info.\n\
");
  return 1;
 }

 // 
 printf("Parsing...");
 fflush(stdout);
 if ( (f=fopen(argv[fname_arg],"rb"))==NULL )
 {
  printf("Error: Cannot open input file.\n");
  return 1;
 }

 // 塞 ᨢ 稪
 for (i=0;i<COMB;i++)
 {
  symnum[i].sym=i;
  symnum[i].num=0;
 }

 //뢠 - ࠧ 権  2 ᨬ
 parse();
 fclose(f);
 printf("done.\n");
 fflush(stdout);

 // 㥬
 if (sort_count)
  sort();

 // 뢠 १
 result();

 return 0;
}


void parse()
{
 int b,oldb;

 if ( (b=getc(f))!=EOF )
 {
  oldb=b;
  while ( (b=getc(f))!=EOF )
  {
   symnum[(b<<8)+oldb].num++;
   oldb=b;
  }
 }
}


void sort()
{
 int flag,i,j,k=sort_count,lastswap;

 printf("Sorting...");
 fflush(stdout);

 // ᪫砥 㫥 樨
 comb_num=0;
 for (i=0;i<COMB;i++)
  if (symnum[i].num)
   symnum[comb_num++]=symnum[i];

 // ᮡ⢥ ஢
 j=0;
 do
 {
  flag=0;
  for (i=comb_num-1;i>=j;i--)
   if (symnum[i].num<symnum[i+1].num)
   {
    twochar tmp=symnum[i];
    symnum[i]=symnum[i+1];
    symnum[i+1]=tmp;
    lastswap=i+1;
    flag=1;
   }
  j=lastswap;
  if (!--k)
   break;
 }
 while (flag);
 printf("done.\n");
 fflush(stdout);
}


void result()
{
 printf("Write result...");
 fflush(stdout);
 //  १
 if ( (f=fopen("result","wt"))==NULL )
 {
  printf("Error: Cannot create result file.\n");
  return;
 }

 uchar lo,hi,loc,hic;

 if (!sort_count)
  sort_count=65536;
 if (comb_num>sort_count)
  comb_num=sort_count;
 for (int i=0;i<comb_num;i++)
  if (symnum[i].num)
  {
   loc=lo=symnum[i].sym&0xFF;
   hic=hi=symnum[i].sym>>8;
   if (loc<' ')
    loc='.';
   if (hic<' ')
    hic='.';
   fprintf(f,"\"%c%c\"  %02X %02X   -   %u\n",loc,hic,lo,hi,symnum[i].num);
  }
 fclose(f);
 printf("done.\n");
 fflush(stdout);
}
